(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/animations'), require('@angular/platform-browser/animations')) :
    typeof define === 'function' && define.amd ? define('ngx-dynamic-carousel', ['exports', '@angular/common', '@angular/core', '@angular/animations', '@angular/platform-browser/animations'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-dynamic-carousel'] = {}, global.ng.common, global.ng.core, global.ng.animations, global.ng.platformBrowser.animations));
}(this, (function (exports, common, core, animations, animations$1) { 'use strict';

    var fadeIn = animations.animation([
        animations.style({ opacity: 0 }),
        animations.animate('2s', animations.style({ opacity: 1 })),
    ]);
    var scaleIn = animations.animation([
        animations.style({ opacity: 0, transform: 'scale(0.5)' }),
        animations.animate('2s', animations.style({ opacity: 1, transform: 'scale(1)' })),
    ]);
    var NgxDynamicCarouselComponent = /** @class */ (function () {
        function NgxDynamicCarouselComponent(cdRef) {
            this.cdRef = cdRef;
            this.items = [];
            this.animationState = 'fade';
            this.autoPlayInterval = 0;
            this.visibleCount = 1;
        }
        NgxDynamicCarouselComponent.prototype.ngOnInit = function () {
            this.resetIndex();
        };
        NgxDynamicCarouselComponent.prototype.ngOnChanges = function (changes) {
            this.lastIndex = (changes === null || changes === void 0 ? void 0 : changes.visibleCount.currentValue) - 1;
        };
        NgxDynamicCarouselComponent.prototype.ngAfterViewInit = function () {
            var _this = this;
            if (this.autoPlayInterval) {
                setInterval(function () {
                    _this.loop('right');
                    _this.cdRef.markForCheck();
                }, this.autoPlayInterval);
            }
        };
        NgxDynamicCarouselComponent.prototype.right = function () {
            this.firstIndex = this.firstIndex + 1;
            this.lastIndex = this.lastIndex + 1;
        };
        NgxDynamicCarouselComponent.prototype.left = function () {
            this.firstIndex = this.firstIndex - 1;
            this.lastIndex = this.lastIndex - 1;
        };
        NgxDynamicCarouselComponent.prototype.loop = function (direction) {
            if (direction === 'left') {
                if (this.firstIndex !== 0) {
                    this.left();
                }
                else {
                    this.resetIndex();
                }
            }
            else {
                if (this.lastIndex !== this.items.length - 1) {
                    this.right();
                }
                else {
                    this.resetIndex();
                }
            }
        };
        NgxDynamicCarouselComponent.prototype.resetIndex = function () {
            this.firstIndex = 0;
            this.lastIndex = this.visibleCount - 1;
        };
        NgxDynamicCarouselComponent.prototype.trackByFn = function () {
            return Math.random();
        };
        return NgxDynamicCarouselComponent;
    }());
    NgxDynamicCarouselComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'ngx-dynamic-carousel',
                    template: "<div class=\"flex items-center justify-around\">\n    <div [class.disabled]=\"firstIndex == 0\" (click)=\"left()\">\n        <ng-container *ngTemplateOutlet=\"leftArrowTemplate ? leftArrowTemplate : defaultLeftArrowTemplate\">\n        </ng-container>\n        <ng-template #defaultLeftArrowTemplate>\n            <- </ng-template>\n    </div>\n    <div *ngFor=\"let item of items.slice(firstIndex, lastIndex + 1); index as i; trackBy: trackByFn\" [@animationTrigger]=\"animationState\">\n        <ng-template [ngTemplateOutlet]=\"mainContentTemplate\" [ngTemplateOutletContext]=\"{ $implicit: item }\">\n        </ng-template>\n    </div>\n\n    <div [class.disabled]=\"lastIndex == items.length - 1\" (click)=\"right()\">\n        <ng-container *ngTemplateOutlet=\"rightArrowtemplate ? rightArrowtemplate : defaultRightArrowTemplate\">\n        </ng-container>\n        <ng-template #defaultRightArrowTemplate>-></ng-template>\n    </div>\n</div>",
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    animations: [
                        animations.trigger('animationTrigger', [
                            animations.transition('void=>scale', [animations.useAnimation(scaleIn)]),
                            animations.transition('void=>fade', [animations.useAnimation(fadeIn)]),
                        ]),
                    ],
                    styles: ["\n      .disabled {\n        pointer-events: none;\n        opacity: 50%;\n      }\n    "]
                },] }
    ];
    NgxDynamicCarouselComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    NgxDynamicCarouselComponent.propDecorators = {
        mainContentTemplate: [{ type: core.Input }],
        leftArrowTemplate: [{ type: core.Input }],
        rightArrowtemplate: [{ type: core.Input }],
        items: [{ type: core.Input }],
        animationState: [{ type: core.Input }],
        autoPlayInterval: [{ type: core.Input }],
        visibleCount: [{ type: core.Input }]
    };

    var NgxDynamicCarouselModule = /** @class */ (function () {
        function NgxDynamicCarouselModule() {
        }
        return NgxDynamicCarouselModule;
    }());
    NgxDynamicCarouselModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        NgxDynamicCarouselComponent,
                    ],
                    imports: [
                        common.CommonModule,
                        animations$1.BrowserAnimationsModule
                    ],
                    exports: [
                        NgxDynamicCarouselComponent,
                    ]
                },] }
    ];

    /*
     * Public API Surface of ngx-dynamic-carousel
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxDynamicCarouselModule = NgxDynamicCarouselModule;
    exports.ɵa = fadeIn;
    exports.ɵb = scaleIn;
    exports.ɵc = NgxDynamicCarouselComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-dynamic-carousel.umd.js.map
